SystemOrganization addCategory: #'Amop-Core'!
SystemOrganization addCategory: #'Amop-Core-Compiler'!
SystemOrganization addCategory: #'Amop-Test-Core'!
SystemOrganization addCategory: #'Amop-Test-Future'!
SystemOrganization addCategory: #'Amop-Test-Ownership'!
SystemOrganization addCategory: #'Amop-Test-DynamicBinding'!
SystemOrganization addCategory: #'Amop-Test-ReadOnly'!
SystemOrganization addCategory: #'Amop-Test-Membrane'!
SystemOrganization addCategory: #'Amop-Compiler'!

Trait named: #DoerTrait
	uses: {}
	category: 'Amop-Test-Core'!

!DoerTrait methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:20'!
computeSumOnObject: anObject
	^ anObject twiceComputeSum .! !

!DoerTrait methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:20'!
invokeTrapForComputeSumOnObject: anObject
	^ anObject  trap: [ :o | o twiceComputeSum ] selector: #twiceComputeSum arguments:{ } ! !

Trait named: #TNoopTrap
	uses: {}
	category: 'Amop-Core'!

TNoopTrap classTrait
	uses: TNoopTrap!

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 16:34'!
baseObject
	^self ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
classTrap: argument 
	Logger show: 'Class '; show: 'xxx'  ; cr. 	 
	^ argument. ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
equals: anObject
	Logger show: 'other: '; show: anObject class asString; cr. 
	^ super = anObject baseObject ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
identityEquals: anObject
	Logger show: 'other: '; show: anObject class asString; cr. 
	^ MetaProxyHandler receiverProxy literalTrap: ( super == anObject baseObject )! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
literalTrap: argument
	Logger show: 'Literal '; show: 'xxx'  ; cr. 	
	^ ValueProxy resolve: argument. ! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
readField: field 
	Logger show: 'Read '; show: field ; cr. 
	^self  instVarNamed: field 
	
	! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:31'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message targetWithArgs  |
	
	((selector beginsWith: #trap) or: [ MetaProxyHandler receiverProxy isAmopProxy and: [ MetaProxyHandler receiverProxy baseObject == self ] ]) ifTrue: [ MessageNotUnderstood signal ].
	
	Logger show: 'NoProxy@'; show: self class asString; show: '>>trap ';  show: selector ; cr. 
		
	"sender of this message is the old receiver"
	sender := MetaProxyHandler receiverProxy. 
	senderHandler := MetaProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := #NoHandler.
	MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	[	
		targetWithArgs := OrderedCollection new.
		targetWithArgs add: self . 
		targetWithArgs addAll: arguments. 
		^ block valueWithArguments: targetWithArgs .
	] ensure: [
		MetaProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	! !

!TNoopTrap methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:41'!
writeField: field value: val 
	Logger show: 'Write '; show: field ; show: self class asString;  cr.
	^self  instVarNamed: field put: val. 
	
	! !

Trait named: #TOwnership
	uses: {}
	category: 'Amop-Test-Ownership'!

!TOwnership methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:55'!
owner
	^ OwnershipUtil ownerOf: self ! !

Object subclass: #BaseObject
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

BaseObject class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

!BaseObject class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 14:52'!
isAmopMeta
	^false! !

!BaseObject class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
new
	"Same as Behavior>>new, but as if it was compiled with our compiler"
	Logger show: 'BaseObject>>new' ; cr.
	^ ( MetaProxyHandler receiverProxy  trap: [ :cls | cls basicNew  ] selector: #basicNew arguments:{ } )  trap: [ :o | o initialize  ] selector: #initialize arguments:{ } ! !

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 14:52'!
isAmopMeta
	^false! !

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
receiverProxy 
	"TODO walk up the chain until the LAST proxy, consider chains of proxy and super sends"
	"self receiverProxy returns the caller of the current activation"
	^ MetaProxyHandler receiverProxy.! !

BaseObject subclass: #BaseProxyHandler
	instanceVariableNames: 'target'
	classVariableNames: 'Receiver ReceiverHandler'
	poolDictionaries: ''
	category: 'Amop-Core'!

!BaseProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:14'!
compilerClass 
	^AmopCompiler! !

!BaseProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:16'!
target: aTarget
	^ self new target: aTarget ; yourself. ! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
classTrapContinue: proceed 
	^ proceed value.  ! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
literalTrapContinue: proceed 
	| v |
	v:= proceed value. 
	( v isAmopProxy and: [ v isValueProxy ]  ) ifTrue: [
		^ v. 
	].
	^ ValueProxy resolve: v. ! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
messageIn: aMessage sender: senderHandler continue: proceed
	^ proceed value: aMessage arguments.! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
readField: aField  continue: proceed
	^ proceed value.! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
target
	^ target.! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
target: aTarget
	target := aTarget.! !

!BaseProxyHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:15'!
writeField: aField value: aValue continue: proceed
	^ proceed value: aValue.! !

BaseObject subclass: #Counter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

Counter class
	instanceVariableNames: 'val'!

Counter class
	instanceVariableNames: 'val'!

!Counter class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 15:20'!
counter 
	^val! !

!Counter class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 15:20'!
inc 
	val := val + 1.! !

!Counter class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 15:20'!
reset
	val := 0! !

BaseObject subclass: #DoerBaseImpl
	uses: DoerTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

DoerBaseImpl class
	uses: DoerTrait classTrait
	instanceVariableNames: ''!

!DoerBaseImpl class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 16:25'!
compilerClass 
	^AmopCompiler! !

BaseObject subclass: #DoerTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!DoerTarget class methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:00'!
compilerClass 
	^AmopCompiler! !

!DoerTarget methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:39'!
computeSum

	| sender receiver senderHandler receiverHandler target message targetWithArgs  |
	<meta>
	
	(MetaProxyHandler receiverProxy isSelfProxyOf: self ) ifTrue: [ ^ self orig_computeSum  ].
		
	Logger show: 'NoProxy@'; show: self class asString; show: '>>trap ';  show: #computeSum ; cr. 
		
	"sender of this message is the old receiver"
	sender := MetaProxyHandler receiverProxy. 
	senderHandler := MetaProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := #NoHandler.
	MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	[	
		^ self orig_computeSum 
	] ensure: [
		MetaProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	! !

!DoerTarget methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:19'!
orig_computeSum
	
	^ 21 + 21! !

!DoerTarget methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:18'!
orig_twiceComputeSum
	^ self computeSum + self computeSum ! !

!DoerTarget methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
trap: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message targetWithArgs  |
	<meta>
	
	(((selector beginsWith: #trap) or:
	 [ MetaProxyHandler receiverProxy isSelfProxyOf: self  ]) or: 
	 [ MetaProxyHandler receiverProxy isAmopMeta  ])  ifTrue: [ MessageNotUnderstood signal ].
	
	targetWithArgs := OrderedCollection new.
	targetWithArgs add: self . 
	targetWithArgs addAll: arguments. 
	^ block valueWithArguments: targetWithArgs .
	! !

!DoerTarget methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:39'!
twiceComputeSum

	| sender receiver senderHandler receiverHandler target message targetWithArgs  |
	<meta>
	
	(MetaProxyHandler receiverProxy isSelfProxyOf: self ) ifTrue: [ ^ self orig_twiceComputeSum  ].
	
	Logger show: 'NoProxy@'; show: self class asString; show: '>>trap ';  show: #computeSum ; cr. 
		
	"sender of this message is the old receiver"
	sender := MetaProxyHandler receiverProxy. 
	senderHandler := MetaProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := #NoHandler.
	MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	[	
		^ self orig_twiceComputeSum 
	] ensure: [
		MetaProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	! !

BaseObject subclass: #DynamicBindingTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!DynamicBindingTester class methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:04'!
compilerClass 
	^AmopCompiler! !

!DynamicBindingTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:16'!
testSteps
	| head  s scope |
	
	head := Step new.
	head next: Step new.
	s := head next.  
	s next: Step new.
	s := s next.  
	s next: Step new.
	
	scope := DynamicBindingUtil scopeWith: 42 .
	^ scope do: [ :p | p doSteps ] with: head. ! !

BaseObject subclass: #Facade
	instanceVariableNames: 'helper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!Facade class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 14:39'!
compilerClass 
	^AmopCompiler! !

!Facade methodsFor: 'class' stamp: 'ewe 2/8/2013 16:45'!
classCompute42
	^ Helper return42 ! !

!Facade methodsFor: 'class' stamp: 'ewe 2/12/2013 15:42'!
classMemoizeSum
 	^ Helper new memoize: 20 sum: 22 . ! !

!Facade methodsFor: 'initialize-release' stamp: 'ewe 2/7/2013 16:03'!
clazz
	^ self class ! !

!Facade methodsFor: 'compute' stamp: 'ewe 9/5/2012 14:22'!
computeSum
 	^ helper compute: 21 sum: 21 .  ! !

!Facade methodsFor: 'closure' stamp: 'ewe 2/7/2013 17:40'!
doBooleanClassClosure
"TODO should be wrapped"
	^   true ifTrue: [ self clazz ]  
   ! !

!Facade methodsFor: 'closure' stamp: 'ewe 2/7/2013 16:04'!
doHelperClassClosure
"TODO should be wrapped"
^ helper do:  [ self clazz ].       
   ! !

!Facade methodsFor: 'closure' stamp: 'ewe 2/7/2013 16:04'!
doSelfClass
"TODO should be wrapped"
^   self clazz. 
 ! !

!Facade methodsFor: 'closure' stamp: 'ewe 2/14/2013 10:18'!
doSelfClassClosure
"TODO should be wrapped"
^  [ self clazz ] value.    
   ! !

!Facade methodsFor: 'initialize-release' stamp: 'ewe 2/14/2013 13:49'!
initialize
	helper := Helper new.. ! !

!Facade methodsFor: 'equality' stamp: 'ewe 2/14/2013 13:38'!
isEqualTo2: anotherObject 
 
	^ anotherObject == self! !

!Facade methodsFor: 'equality' stamp: 'ewe 2/14/2013 13:38'!
isEqualTo: anotherObject 

	^ self == anotherObject.! !

!Facade methodsFor: 'compute' stamp: 'ewe 9/3/2012 12:12'!
memoizeSum
 	^ helper memoize: 20 sum: 22 . ! !

!Facade methodsFor: 'compute' stamp: 'ewe 9/3/2012 12:12'!
mockSum 
 	^ helper mock: 0 sum: 0 . ! !

!Facade methodsFor: 'return' stamp: 'ewe 8/28/2012 12:01'!
return42
	^ 42! !

!Facade methodsFor: 'return' stamp: 'ewe 2/8/2013 16:43'!
returnObject
	^ Helper new. ! !

!Facade methodsFor: 'return' stamp: 'ewe 2/8/2013 14:09'!
returnSelf
	^ self ! !

!Facade methodsFor: 'return' stamp: 'ewe 9/3/2012 16:52'!
selfReturn42
	^ self return42! !

!Facade methodsFor: 'return' stamp: 'ewe 8/30/2012 10:47'!
selfReturnObject
	^ self returnObject  ! !

!Facade methodsFor: 'return' stamp: 'ewe 2/8/2013 14:10'!
selfReturnSelf
	^ self returnSelf  ! !

!Facade methodsFor: 'compute' stamp: 'ewe 9/6/2012 11:09'!
twiceComputeSum
 	^ self computeSum + self computeSum ! !

!Facade methodsFor: 'compute' stamp: 'ewe 9/6/2012 11:09'!
twiceMemoizeSum
 	^ self memoizeSum + self memoizeSum ! !

!Facade methodsFor: 'compute' stamp: 'ewe 2/13/2013 10:31'!
twiceMockSum
 	^ self mockSum  + self mockSum! !

!Facade methodsFor: 'compute' stamp: 'ewe 2/13/2013 10:31'!
twiceMockSumMeta
	<meta>
 	^ self mockSum  + self mockSum  ! !

Facade subclass: #SubFacade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:02'!
return42
	^super return42.! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
returnObject 
	^super returnObject.! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:47'!
selfReturn42
	^ super selfReturn42 ! !

!SubFacade methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
selfReturnObject
	^ super selfReturnObject! !

BaseObject subclass: #Helper
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!Helper class methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:15'!
compilerClass 
	^AmopCompiler! !

!Helper class methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 16:00'!
return42
	^42 ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 12:22'!
compute: v1 sum: v2 
	^v1 + v2. ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:14'!
do: aBlock
	^ aBlock value. ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 15:40'!
initialize
	key := nil.
	value:= nil. ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 13:49'!
memoize: v1 sum: v2
	( key = { v1 . v2 } ) ifFalse: [  
		key := { v1 . v2 }.   
		value := v1 + v2  
	]. 
	^ value.! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:05'!
mock: v1 sum: v2
	^42! !

BaseObject subclass: #Holder
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!Holder class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:42'!
compilerClass
	^ AmopCompiler ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:54'!
get
	^value ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:22'!
get2
	self get get! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:42'!
reset
	value := nil. ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:22'!
reset2
	self get reset. ! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:22'!
set2: v
	self get set: v! !

!Holder methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:54'!
set: val
	value := val. ! !

BaseObject subclass: #Logger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

Logger class
	instanceVariableNames: 'active'!

Logger class
	instanceVariableNames: 'active'!

!Logger class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:26'!
activate
	active := true! !

!Logger class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:26'!
cr
	<meta>
	active ifTrue: [ Transcript cr ]! !

!Logger class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:26'!
deactivate
	active := false! !

!Logger class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:26'!
show: aString
	<meta>
	active ifTrue: [ Transcript show: aString ]! !

BaseObject subclass: #MembraneTester
	instanceVariableNames: 'membrane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!MembraneTester class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:41'!
compilerClass 
	^AmopCompiler ! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 17:03'!
setInUp
	| safe wrappedDevious devious |

	devious := Holder new.
	membrane := Membrane new. 
	wrappedDevious := membrane proxyFor: devious. 
	
	safe := Holder new. 
	safe set: 42.  
		
	wrappedDevious set: safe .
	
	^ devious  .! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 17:03'!
setOutUp
	| safe wrappedDevious devious |

	devious := Holder new.
	devious set: 42.  
	
	membrane := Membrane new. 
	wrappedDevious := membrane proxyFor: devious. 
	
	safe := Holder new. 
	safe set: wrappedDevious.
	
	^ safe.! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:24'!
testInMembrane  
	| devious |
	devious := self setInUp. 
	^ devious get get .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:48'!
testInMembraneIndempotence
	| devious |
	devious := self setInUp. 
	^ { devious get get  . devious get get } .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:53'!
testInMembraneIndempotence2
	| devious |
	devious := self setInUp. 
	^ devious get get  == devious get get  .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:24'!
testInRevokeMembrane 
	| devious |
	devious := self setInUp. 
	membrane revoke. 
	^ devious get get .	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:07'!
testOutMembrane 
	| safe |
	safe := self setOutUp. 
	^ safe get get .
	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:50'!
testOutMembraneIndempotence
	| safe |
	safe := self setOutUp. 
	^ { safe get get . safe get get} .	
	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:53'!
testOutMembraneIndempotence2
	| safe |
	safe := self setOutUp. 
	^  safe get get == safe get get.	
	! !

!MembraneTester methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:07'!
testOutRevokeMembrane 
	| safe |
	safe := self setOutUp. 
	membrane revoke. 
	^ safe get get .
	! !

BaseObject subclass: #OList
	uses: TOwnership
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

OList class
	uses: TOwnership classTrait
	instanceVariableNames: ''!

!OList class methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:23'!
compilerClass 
	^AmopCompiler! !

!OList methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:29'!
addFirst: aValue
	| node | 
	node := ONode new.
	node content: aValue .
	node  next: head.
	head := node! !

!OList methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:29'!
head
	^head! !

!OList methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:51'!
initialize
	head := nil .
	^self ! !

!OList methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:29'!
removeFirst
	| value  |
	( head == nil ) ifTrue: [ Error signal ].
	value  := head content .
	head := head next. 
	^value! !

BaseObject subclass: #ONode
	uses: TOwnership
	instanceVariableNames: 'next content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

ONode class
	uses: TOwnership classTrait
	instanceVariableNames: ''!

!ONode class methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:23'!
compilerClass 
	^AmopCompiler! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/14/2013 15:28'!
content
	^content! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/15/2013 11:30'!
content: c
	content := c! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/14/2013 17:20'!
initialize 
	^self! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/14/2013 15:26'!
isLast
	^ next == nil! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/14/2013 15:25'!
next
	^ next! !

!ONode methodsFor: 'accessing' stamp: 'ewe 2/14/2013 15:25'!
next: anObject
	next := anObject! !

BaseObject subclass: #OwnershipTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!OwnershipTester class methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:24'!
compilerClass 
	^AmopCompiler! !

!OwnershipTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:32'!
testListHead
	| list |
	list := OList new. 
	list addFirst: #1.
	^ list head value  ! !

!OwnershipTester methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:44'!
testListOwner
	| list |
	list := OList new. 
	list addFirst: #1.
	^ list owner ! !

BaseObject subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!Scope class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 14:39'!
compilerClass 
	^AmopCompiler! !

!Scope methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:47'!
do: aBlock with: o 
	"TODO raise execption if block has bound variable "
	^ aBlock value: o ! !

BaseObject subclass: #Step
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!Step class methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:09'!
compilerClass 
	^AmopCompiler! !

!Step methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:15'!
doSteps 
	( next = nil ) ifTrue: [ ^ self getCurrent ].
	^ self getCurrent + next doSteps. ! !

!Step methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:00'!
getCurrent
	^ DynamicBindingUtil currentFor: self ! !

!Step methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:06'!
initialize 
	next := nil. ! !

!Step methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:10'!
next 
	^next ! !

!Step methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:09'!
next: aStep
	next := aStep. 
	! !

BaseObject subclass: #Syntax
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!Syntax class methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 11:54'!
compilerClass 
	^AmopCompiler! !

!Syntax methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 13:28'!
allSyntax
	| x |
	"literal"
	x := 1. 
	"array literal"
	x := #( 1 2 3 #(4 5) ). 
	 "array"
	x := { x .x  }. 
	"array with literal "
	x := { 1 .2 } . 
	"message send "
	x message: x.  
	"message send with possible meta-confusion"
	x  trap: [ :o | o computeSum ] selector: #computeSum arguments:{ } . 
	 ! !

Object subclass: #MetaObject
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

MetaObject class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

MetaObject subclass: #Binding
	instanceVariableNames: 'currentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!Binding methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:54'!
currentValue
	^ currentValue! !

!Binding methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:54'!
currentValue: anObject
	currentValue := anObject! !

MetaObject subclass: #DoerMetaImpl
	uses: DoerTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

DoerMetaImpl class
	uses: DoerTrait classTrait
	instanceVariableNames: ''!

MetaObject subclass: #DynamicBindingUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!DynamicBindingUtil class methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:00'!
currentFor: aProxy

 	^ aProxy handler val
	! !

!DynamicBindingUtil class methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:41'!
scopeWith:  aVal 

	| h p scope |
	self flag: 'Should be #new '.
	scope := Scope trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	p := Proxy for: scope handlerClass: DynamicBindingHandler .. 
	p handler val: aVal. 
	^ p. 	! !

!DynamicBindingUtil class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 09:22'!
valueOf: aKey for: aProxy
   | h p |
   p := aProxy.
   [ p isProxy ] whileTrue: [
      h := p handler. 	
      ( h bindingKey == aKey ) ifTrue: [ 
         ^ h bindingValue.
      ].
      p := h target.
   ].
   ^nil. "Not found"! !

MetaObject subclass: #Membrane
	instanceVariableNames: 'references revoked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:01'!
add: reference
	references add: reference. ! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:45'!
initialize
	references := IdentitySet new.
	revoked := false! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 13:45'!
isRevoked 
	^ revoked ! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:04'!
proxyFor: aTarget
	| proxy handler |
	handler := MembraneHandler new. 
	handler target: aTarget.
	handler membrane: self. 
	proxy := Proxy handler: handler. 
	self add: proxy. 
	^proxy! !

!Membrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:04'!
revoke
	revoked := true. 
	references do: [ :ref  | ref handler revoke ].! !

!MetaObject class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 14:52'!
isAmopMeta
	^true! !

!MetaObject methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 14:52'!
isAmopMeta
	^true! !

MetaObject subclass: #MetaProxyHandler
	instanceVariableNames: 'target'
	classVariableNames: 'Receiver ReceiverHandler'
	poolDictionaries: ''
	category: 'Amop-Core'!

MetaProxyHandler subclass: #MembraneHandler
	instanceVariableNames: 'membrane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 12:03'!
failIfRevoked
	(self isRevoked )ifTrue: [ RevokedMembraneError signal: 'Membrane was revoked'].! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:43'!
isRevoked
	^ membrane isRevoked. ! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:52'!
membrane
	 ^membrane.! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 15:52'!
membrane: aMembrane
	membrane := aMembrane.! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:03'!
messageIn: aMessage sender: senderHandler continue: proceed
	| inArgs  |
	self failIfRevoked.
	inArgs := aMessage arguments collect: [ :arg |  membrane proxyFor: arg  ].	
	^ membrane proxyFor: ( proceed value: inArgs )! !

!MembraneHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 16:05'!
revoke
	target := nil. ! !

!MetaProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 12:19'!
receiverProxy
	<meta>
	^Receiver ! !

!MetaProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 12:19'!
receiverProxy: anObject 
	<meta>
	^ Receiver := anObject.! !

!MetaProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 12:19'!
receiverProxy: anObject handler: aHandler
	<meta>
	 Receiver := anObject.
	  ReceiverHandler:=aHandler.! !

!MetaProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 12:19'!
receiverProxyHandler
	<meta>
	^ReceiverHandler! !

!MetaProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	^ self new target: aTarget ; yourself. ! !

!MetaProxyHandler methodsFor: 'trap' stamp: 'ewe 2/8/2013 16:28'!
classTrapContinue: proceed 
	^ proceed value. ! !

!MetaProxyHandler methodsFor: 'trap' stamp: 'ewe 2/7/2013 17:16'!
literalTrapContinue: proceed 
	| v |
	v:= proceed value. 
	( v isAmopProxy and: [ v isValueProxy ]  ) ifTrue: [
		^ v. 
	].
	^ ValueProxy resolve: v. ! !

!MetaProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:05'!
messageIn: aMessage sender: senderHandler continue: proceed
	^ proceed value: aMessage arguments.! !

!MetaProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 16:24'!
readField: aField  continue: proceed
	^ proceed value.! !

!MetaProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target
	^ target.! !

!MetaProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	target := aTarget.! !

!MetaProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:06'!
writeField: aField value: aValue continue: proceed
	^ proceed value: aValue.! !

MetaProxyHandler subclass: #MetaTransitiveHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

MetaTransitiveHandler subclass: #BaseOwnershipHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 17:28'!
canReference: anotherHandler
	| owners |
	
	Logger show: self target asString ; show: ' can reference ' ; show: anotherHandler target asString ; cr. 
	
	anotherHandler owner isNil ifTrue: [ ^self ].
	Logger show: ' 1xxx' ; cr. 
	( anotherHandler owner = self ) ifTrue: [ ^self].
	Logger show: ' 2xxx' ; cr. 
	( anotherHandler owner = self owner ) ifTrue: [ ^self].
	Logger show: ' 3xxx' ; cr. 
	owners := self owners , { self }. 
	Logger show: ' 4xxx' ; cr. 
	(owners includes: anotherHandler ) ifFalse: [ OwnershipError signal ]
	
	! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:25'!
classTrapContinue: proceed 
	| w newHandler  |
	w := super classTrapContinue: proceed. 
	newHandler :=  ImpersonatorHandler new. 
	newHandler target: w handler target.
	newHandler impersonated: self. 
	w handler: newHandler. 
	^ w.  ! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:28'!
handlerClass
	^  OwnershipHandler! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:36'!
identity
	self subclassResponsibility ! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:09'!
messageIn: aMessage sender: originalProxy continue: proceed
	| retVal senderHandler |
	
	senderHandler := MetaProxyHandler receiverProxyHandler.. 
	
	(senderHandler respondsTo: #identity ) ifFalse: [
		^ super messageIn: aMessage sender:  senderHandler continue: proceed.
	].

	Logger show: 'Sender  id: ' ; show: senderHandler target  asString ; cr. 
	Logger show: 'Target  id: ' ; show: self target asString ; cr. 
	Logger show: 'Sender identity  id: ' ; show: senderHandler identity  target  asString ; cr. 
	Logger show: 'Target identity  id: ' ; show: self identity target asString ; cr. 
	
	( aMessage selector = #basicNew ) ifTrue: [ 
		Logger show: '### Start New';cr. 
		retVal := super messageIn: aMessage sender:  senderHandler continue: proceed.
		"We assume the class is impersonated" 
		Logger show: 'New owner is ' ; show: senderHandler impersonated  target asString ; cr. 
		retVal handler owner: senderHandler impersonated. 
		Logger show: '### End new';cr. 
		^retVal
	].
	Logger show: 'sel --> ' ; show: aMessage selector ; cr. 
	aMessage arguments do: [ :each | self identity canReference: each handler identity ].
	retVal := super messageIn: aMessage sender:  senderHandler continue: proceed.
	
	Logger show: 'Ret   id: ' ; show: retVal target asString ; cr. 
	Logger show: 'Ret identity  id: ' ; show: retVal handler identity target asString ; cr. 
	
	senderHandler identity canReference: retVal handler identity . 
	
	Logger show: 'Done' ; cr.
	^retVal! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 17:07'!
owners 
	self owner = nil ifTrue: [ ^ {} ].
	^ self owner owners , { self owner }! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 17:30'!
readField: aField  continue: proceed
	| roproxy proxy |
	proxy := proceed value.  
	Logger show: 'xxxx Read '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^proxy! !

!BaseOwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 17:30'!
writeField: aField value: proxy continue: proceed
	Logger show: 'Write '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^ proceed value: proxy.  ! !

BaseOwnershipHandler subclass: #ImpersonatorHandler
	instanceVariableNames: 'impersonated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!ImpersonatorHandler methodsFor: 'accessing' stamp: 'ewe 2/14/2013 16:36'!
identity
	^ impersonated ! !

!ImpersonatorHandler methodsFor: 'accessing' stamp: 'ewe 2/14/2013 16:20'!
impersonated
	^ impersonated! !

!ImpersonatorHandler methodsFor: 'accessing' stamp: 'ewe 2/14/2013 16:20'!
impersonated: anObject
	impersonated := anObject! !

!ImpersonatorHandler methodsFor: 'accessing' stamp: 'ewe 2/14/2013 16:21'!
owner
	^ impersonated owner ! !

!ImpersonatorHandler methodsFor: 'accessing' stamp: 'ewe 2/14/2013 16:22'!
owner: anObject
	impersonated owner: anObject! !

BaseOwnershipHandler subclass: #OwnershipHandler
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!OwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:36'!
identity
	^self! !

!OwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:21'!
owner
	^owner! !

!OwnershipHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 15:21'!
owner: anObject
	owner := anObject! !

MetaTransitiveHandler subclass: #BaseTracingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!BaseTracingHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 15:22'!
counter
	^ Counter counter! !

!BaseTracingHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 15:21'!
reset
	Counter reset! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:34'!
literalTrapContinue: proceed 
	^super literalTrapContinue: proceed. ! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:02'!
messageIn: aMessage sender: originalProxy continue: proceed
	( self shouldTrace: aMessage sender: originalProxy ) ifTrue: [
		Logger show: '>>>>>' ; show: aMessage selector; cr. 
		Counter inc. 
	].
	^ super messageIn: aMessage sender:  originalProxy continue: proceed.! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:33'!
readField: aField  continue: proceed
	^super readField: aField continue: proceed.! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 12:03'!
shouldTrace: aMessage sender: senderHandler
	self subclassResponsibility ! !

!BaseTracingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:33'!
writeField: aField value: proxy continue: proceed
	super writeField: aField value: proxy continue: proceed. ! !

BaseTracingHandler subclass: #TracingHandlerNoSelfSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TracingHandlerNoSelfSend methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:02'!
shouldTrace: aMessage sender: originalProxy
	^ ( MetaProxyHandler receiverProxy = originalProxy ) not ! !

BaseTracingHandler subclass: #TracingHandlerSelfSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TracingHandlerSelfSend methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 16:02'!
shouldTrace: aMessage sender: originalProxy
	^true! !

MetaTransitiveHandler subclass: #DynamicBindingHandler
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!DynamicBindingHandler methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:57'!
binding
	^ binding! !

!DynamicBindingHandler methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:57'!
binding: anObject
	binding := anObject! !

!DynamicBindingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:54'!
initialize 
	binding := Binding new.! !

!DynamicBindingHandler methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:55'!
val
	^ binding currentValue! !

!DynamicBindingHandler methodsFor: 'accessing' stamp: 'ewe 2/15/2013 12:55'!
val: anObject
	binding currentValue: anObject! !

!DynamicBindingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:58'!
wrap: arg 
	"This wrapper create a new handler with same binding  "
	( arg  isAmopProxy ) ifTrue: [
		 arg handlers detect: [ :h | h isKindOf: self handlerClass ] ifNone: [ 
			Logger show: 'Wrap proxy '; show: arg class asString; cr. 
			^ Proxy handler: (self handlerClass new target: arg ; binding: self binding )   .
		].
		Logger show: 'Wrap bypass ' ; cr. 
		^ arg. 
	].
	Logger show: 'Wrap proxy '; show: arg class asString; cr. 
	^ Proxy handler: (self handlerClass new target: arg ; binding: self binding )    .
! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 16:51'!
classTrapContinue: proceed 
	^self wrap:  proceed value ! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:27'!
handlerClass
	^ self class ! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 11:59'!
literalTrapContinue: proceed 
	"Will wrap the proceed in a ValueProxy"
	^self wrap: ( super literalTrapContinue: proceed ) .! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 12:59'!
messageIn: aMessage sender: senderHandler continue: proceed
	| newArgs |
	newArgs := aMessage arguments collect: [ :arg | self wrap: arg  ] .
	^ self wrap: ( proceed value: newArgs ). ! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 13:55'!
readField: aField  continue: proceed
	| roproxy proxy |
	proxy := proceed value.  
	Logger show: 'xxxx Read '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^self wrap: proxy! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:55'!
unwrap: proxy 
	"TODO check that proxy is of type self class"
	self flag: 'Why do we not wrap object of same class ' .
	( proxy isAmopProxy ) ifTrue: [
		Logger show: 'Unwrap proxy'; cr. 
		^ proxy target. 
	].
	Logger show: 'Unwrap noop'; cr. 
	^ proxy. ! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 16:41'!
wrap: arg 
	self flag: 'Wrapping object of the same kind is bypassed,. We should wrap only the first time an reference frows in a dynamic scope. See issue 6 ' .
	( arg  isAmopProxy ) ifTrue: [
		 arg handlers detect: [ :h | h isKindOf: self handlerClass ] ifNone: [ 
			Logger show: 'Wrap proxy '; show: arg class asString; cr. 
			^ Proxy for: arg  handlerClass: self handlerClass .
		].
		Logger show: 'Wrap bypass ' ; cr. 
		^ arg. 
	].
	Logger show: 'Wrap proxy '; show: arg class asString; cr. 
	^ Proxy for: arg  handlerClass: self handlerClass .
! !

!MetaTransitiveHandler methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 13:55'!
writeField: aField value: proxy continue: proceed
	Logger show: 'Write '; show: aField ; show: ' '; show: proxy class asString ; cr.
	^ proceed value: (self unwrap: proxy ).  ! !

MetaTransitiveHandler subclass: #ReadOnlyChainingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-ReadOnly'!

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:35'!
literalTrapContinue: proceed 
	^super literalTrapContinue: proceed.! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2012 11:35'!
readField: aField  continue: proceed
	^super readField: aField continue: proceed.! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:33'!
writeField: aField value: aValue continue: proceed
	ReadOnlyError signal:  'Read only handler can not write'. ! !

MetaObject subclass: #OwnershipUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!OwnershipUtil class methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:58'!
ownerOf: aProxy
	" ''handler owner'' is another handler. We should actually return a proxy whose handler is 'handler owner' '"
	Logger show: 'Owner of '; show: aProxy asString ; show: ' is '; show: aProxy handler owner target asString ; cr. 
	^ aProxy handler owner target! !

MetaObject subclass: #Proxy
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!Proxy class methodsFor: 'for' stamp: 'ewe 2/21/2013 14:15'!
for: aTarget
	^ self for: aTarget handlerClass: MetaProxyHandler ! !

!Proxy class methodsFor: 'for' stamp: 'ewe 2/13/2013 13:55'!
for: aTarget handlerClass: handlerClass
	| proxAndHandler |
	Logger show: 'Proxy for..'; cr.  
	proxAndHandler := self proxy: aTarget handlerClass: handlerClass. 
	^ proxAndHandler at: 1. ! !

!Proxy class methodsFor: 'handler' stamp: 'ewe 8/31/2012 11:47'!
handler: aHandler
	^ self new handler: aHandler ; yourself.! !

!Proxy class methodsFor: 'proxyHandler' stamp: 'ewe 9/4/2012 15:26'!
proxy: aTarget handlerClass: handlerClass
	| proxy handler |
	handler := handlerClass target: aTarget. 
	proxy := self handler: handler. 
	"ProxyTrap adoptInstance:  proxy. "
	^ { proxy . handler }. ! !

!Proxy class methodsFor: 'proxyHandler' stamp: 'ewe 2/21/2013 14:15'!
proxyAndHandler: aTarget
	^ self proxy: aTarget handlerClass: MetaProxyHandler. ! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/21/2013 15:21'!
_trap2: block selector: selector arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
		
	"TODO needs refactoring. Must be pushed in subclass"
	( selector == #identityEquals: and: [ self isValueProxy ] ) ifTrue: [
		^ self trap: [ :o :o2 | o == o2 ] selector: #== arguments: arguments 
	].
	
	target := handler target.  
	Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	
	"sender of this message is the old receiver"
	sender := MetaProxyHandler receiverProxy. 
	senderHandler := MetaProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := handler.
	MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 

	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	[ 
		target isAmopProxy ifTrue: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					self transformOutRet: (target chainFrom: receiverHandler  trap: block selector: selector arguments: ( self transformInArgs: argsIn) ) ]
				"]" .
		] ifFalse: [
			^ "senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |"
				receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
					| targetWithArgs |
					targetWithArgs := OrderedCollection new.
					targetWithArgs add: target. 
					targetWithArgs addAll: (self transformInArgs: argsIn ) . 
					self transformOutRet: ( block valueWithArguments: targetWithArgs ) ]
				" ]" .
		]
	] ensure: [
		MetaProxyHandler receiverProxy:  sender handler: senderHandler.. 
	]
	

	! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/5/2012 11:52'!
baseObject 
	| target |
	target  := handler target .
	target isAmopProxy ifTrue: [ 
		^ target baseObject. .
	].
	^ target. ! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/21/2013 15:45'!
chainFrom: originalProxy trap: block selector: selector  arguments: arguments
	
	| target message proceed |
		
	"TODO needs refactoring. Must be pushed in subclass"
	( selector == #identityEquals: and: [ self isValueProxy ] ) ifTrue: [
		^ self trap: [ :o :o2 | o == o2 ] selector: #== arguments: arguments 
	].
	
	( self == originalProxy ) ifTrue: [
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	] ifFalse: [	
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	].

	target := handler target.  
	message := Message selector: selector  arguments: arguments .
		
	target isAmopProxy ifTrue: [
		
		proceed := [ :argsIn |
				self transformOutRet: (target chainFrom: originalProxy trap: block selector: selector arguments: (self transformInArgs: argsIn ) )].
		
		^ handler messageIn: message sender: originalProxy continue: proceed. 
	] ifFalse: [
	
		proceed := [ :argsIn |
				| targetWithArgs oldProxy oldHandler  |
				oldProxy := MetaProxyHandler receiverProxy .
				oldHandler := MetaProxyHandler receiverProxyHandler .
				MetaProxyHandler receiverProxy:  originalProxy  handler: originalProxy handler.. 
				
				targetWithArgs := OrderedCollection new.
				targetWithArgs add: target. 
				targetWithArgs addAll: (self transformInArgs: argsIn ). 
				
				[ 
					self transformOutRet: ( block valueWithArguments: targetWithArgs) 
				] ensure:[ 
					MetaProxyHandler receiverProxy:  oldProxy handler: oldHandler 
				 ]
		].
	
		^ handler messageIn: message sender: originalProxy continue:  proceed. 
	]
	
! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/13/2013 13:55'!
classTrap: argument
	|  target  |
	target := handler target. .
	"TODO do not wrap closure into ValueProxy, but regular Proxy"
	Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>classTrap ' ;  cr.
	
	target isAmopProxy ifTrue: [
		^ handler classTrapContinue: [ target classTrap: argument ].
	] ifFalse: [
		^ handler classTrapContinue: [ argument ].
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/4/2012 11:44'!
handler
 ^handler! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 8/31/2012 11:45'!
handler: aHandler
	handler := aHandler. ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:54'!
handlers 
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^  { handler } , target handlers.  	
	] ifFalse: [
		^ { handler } . 
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy 
	^true! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/12/2013 17:09'!
isLast
	| target |
	target := handler target. 
	^ target isAmopProxy not. ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 1/31/2013 13:26'!
isValueProxy
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^ target isValueProxy.. 	
	] ifFalse: [
		^ false. 
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:58'!
lastHandler
	^self handlers last. ! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:58'!
lastProxy
	^ self proxies last. ! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/13/2013 13:55'!
literalTrap: argument
	|  target  |
	target := handler target. .
	"TODO do not wrap closure into ValueProxy, but regular Proxy"
	Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>literalTrap ' ; cr.
	
	target isAmopProxy ifTrue: [
		^ handler literalTrapContinue: [ target literalTrap: argument ].
	] ifFalse: [
		^ handler literalTrapContinue: [ argument ].
	]! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 2/8/2013 13:54'!
proxies 
	| target|
	target := handler target.  
	target isAmopProxy ifTrue:  [
		^  { self } , target proxies.  	
	] ifFalse: [
		^ { self } . 
	]! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/13/2013 13:55'!
readField: field 
	|  target  |
	target := handler target.  
	Logger show: 'Proxy[' ; show:  self handler class asString ; show: '@'; show: target class asString ; show: ']>>readField ' ; show: field ; cr.
	target isAmopProxy ifTrue: [
		^ handler readField: field 
				continue: [ target readField: field ]
	] ifFalse: [
		^ handler readField: field 
				continue: [ target instVarNamed: field ]
	]
	
	! !

!Proxy methodsFor: 'handler-proxy-chain' stamp: 'ewe 9/5/2012 10:37'!
target
	^handler target! !

!Proxy methodsFor: 'control' stamp: 'ewe 1/31/2013 11:47'!
transformInArgs: args
	^ args.! !

!Proxy methodsFor: 'control' stamp: 'ewe 1/31/2013 11:48'!
transformOutRet: retVal
	^ retVal ! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/21/2013 16:00'!
trap: block selector: selector arguments: arguments

	"We set ourself as the original handler"
	^ self chainFrom: self trap: block selector: selector arguments: arguments 
! !

!Proxy methodsFor: 'traps' stamp: 'ewe 2/13/2013 13:55'!
writeField: field value: value
	|  target  |
	target := handler target.  
	Logger show: 'Proxy[' ; show:  self handler class asString  ; show: '@';  show: target class asString ; show: ']>>writeField ' ; show: field ; cr.
	target isAmopProxy ifTrue: [
		^ handler writeField: field
				value: value  
				continue: [ :val |  target writeField: field value: val ]
	] ifFalse: [
		^ handler writeField: field 
			 value: value
				continue: [ :val | target instVarNamed: field 
							      put: val ]
	]! !

Proxy subclass: #ValueProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

ValueProxy subclass: #BooleanProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!BooleanProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 15:42'!
chainFrom: originalProxy trap: block selector: selector  arguments: arguments
	
	| sender proceed  target message receiver receiverHandler  |
	
	( selector beginsWith: 'if' ) ifFalse: [ Error signal:  'support only evalution of conditionals' ]. 
	
	( self == originalProxy ) ifTrue: [
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	] ifFalse: [	
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	].

	target := handler target.  
	message := Message selector: selector  arguments: arguments .
	
	proceed := [ :argsIn |
		| targetWithArgs oldProxy oldHandler  |
		oldProxy := MetaProxyHandler receiverProxy .
		oldHandler := MetaProxyHandler receiverProxyHandler .
			
		">>rebind the outer context of the closure. See issue 0". 
		receiver := arguments first lastProxy selfProxy.
		receiverHandler := arguments first lastProxy selfProxyHandler . 
		MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 
				
		targetWithArgs := OrderedCollection new.
		targetWithArgs add: target. 
		targetWithArgs addAll: (self transformInArgs: argsIn ). 
				
		[ 
			self transformOutRet: ( block valueWithArguments: targetWithArgs) 
		] ensure:[ 
			MetaProxyHandler receiverProxy:  oldProxy handler: oldHandler 
		 ]
	].
	
	^ handler messageIn: message sender: originalProxy continue:  proceed. 
	! !

ValueProxy subclass: #ClassProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ClassProxy commentStamp: 'ewe 2/12/2013 15:56' prior: 0!
A value proxy for class literals. It does not wrap/unwrap the paramter and return value. !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 15:44'!
chainFrom: originalProxy trap: block selector: selector  arguments: arguments
	
	( selector beginsWith: 'new' ) ifFalse: [ Error signal:  'support only instantiation' ]. 
	^ super chainFrom: originalProxy trap: block selector: selector  arguments: arguments! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 13:38'!
initialize 
	self halt. ! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 15:56'!
transformInArgs: args
	^ args! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 15:56'!
transformOutRet: retVal
	^ retVal ! !

ValueProxy subclass: #ClosureProxy
	instanceVariableNames: 'selfProxy selfProxyHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ClosureProxy class methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:58'!
for: aClosure selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler  
	| p |
	p := super for: aClosure. 
        p selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler .
	^p. ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 15:58'!
chainFrom: originalProxy trap: block selector: selector arguments: arguments
	
	| sender proceed  target message receiver receiverHandler  |
	
	( selector beginsWith: 'value' ) ifFalse: [ Error signal:  'support only evalution of closure' ]. 
	
	( self == originalProxy ) ifTrue: [
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>trap ' ; show: selector ; cr.
	] ifFalse: [	
		Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	].

	target := handler target.  
	message := Message selector: selector  arguments: arguments .
	
	proceed := [ :argsIn |
		| targetWithArgs oldProxy oldHandler  |
		oldProxy := MetaProxyHandler receiverProxy .
		oldHandler := MetaProxyHandler receiverProxyHandler .
			
		"****rebind the outer context of the closure. See issue 0". 
		receiver := self selfProxy.
		receiverHandler := self selfProxyHandler . 
		MetaProxyHandler receiverProxy:  receiver handler: receiverHandler.. 
				
		targetWithArgs := OrderedCollection new.
		targetWithArgs add: target. 
		targetWithArgs addAll: (self transformInArgs: argsIn ). 
				
		[ 
			self transformOutRet: ( block valueWithArguments: targetWithArgs) 
		] ensure:[ 
			MetaProxyHandler receiverProxy:  oldProxy handler: oldHandler 
		 ]
	].
	
	^ handler messageIn: message sender: originalProxy continue:  proceed. 
	
	! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxy
	^selfProxy ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxy: receiverProxy selfProxyHandler: receiverProxyHandler 
	selfProxy := receiverProxy .
	selfProxyHandler:=receiverProxyHandler .! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/7/2013 15:59'!
selfProxyHandler
	^selfProxyHandler ! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:28'!
transformInArgs: args
	^ args! !

!ClosureProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/6/2013 17:28'!
transformOutRet: retVal
	^ retVal ! !

ValueProxy subclass: #NilProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!NilProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 15:59'!
chainFrom: originalProxy trap: block selector: selector  arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message |
	
	
	target := handler target.  
	Logger show:  self class asString ; show: '[' ; show:  self handler class asString ;
		 show: '@'; show: target class asString ; show: ']>>chainTrap ' ; show: selector ; cr.
	
	( selector beginsWith: 'equals' ) ifFalse: [ Error signal:  'support only equality check of nil' ]. 
	
	^ self transformOutRet: (  nil = arguments first baseObject ).! !

!ValueProxy class methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
resolve: v
	( v isKindOf: BlockClosure ) ifTrue: [
		^ ClosureProxy for: v 
					selfProxy: MetaProxyHandler receiverProxy 
					selfProxyHandler: MetaProxyHandler receiverProxyHandler  .
	] .
	( v isKindOf: Boolean ) ifTrue: [
		^ BooleanProxy for: v .
	] .
	( v isKindOf: UndefinedObject ) ifTrue: [
		^ NilProxy for: v .
	] .
	( v isKindOf: Class ) ifTrue: [
		^ v .
	] .
	^ ValueProxy for: v.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 13:26'!
isValueProxy 
	^true! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 16:37'!
literalTrap: argument
		self error: 'Not for value: literalTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
newTrap: argument
	self error: 'Not for value: newTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
readField: field 
	self error: 'Not for value: readField'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 1/31/2013 11:50'!
transformInArgs: args
	^ (args collect: [ :item | item baseObject ]). ! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 13:55'!
transformOutRet: retVal
	Logger show: 'wrap result of value proxy '; show: retVal ; cr. 
	^super literalTrap: retVal ! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:41'!
writeField: field value: value
	self error: 'Not for value: writeField.' . ! !

!Object methodsFor: '*amop' stamp: 'ewe 2/13/2013 15:00'!
isAmopMeta
	^false! !

!Object methodsFor: '*amop' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy
	^false! !

!Object methodsFor: '*amop' stamp: 'ewe 2/14/2013 14:07'!
isSelfProxyOf: anObject
	^self  isAmopProxy and: [ self baseObject == anObject  ]! !

Object subclass: #OwnedObject3
	uses: TOwnershipCheck
	instanceVariableNames: 'dynamicOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

OwnedObject3 class
	uses: TOwnershipCheck classTrait
	instanceVariableNames: ''!

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:45'!
borrow: anObject do: aBlock
	| oldOwner |
	oldOwner := anObject owner. 
	anObject owner: self. 
	[
	  ^aBlock value: anObject. 
	] ensure: [
		anObject owner: oldOwner. 
	]! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/20/2012 11:20'!
canNotSend: selector to: receiver
	[ self canSend: selector to: receiver ] on: MessageFiltered do: [ ^ true ]. 
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/19/2012 16:10'!
canSend: selector to: receiver
	"Tests whether the object can send the message to the receiver"
	self checkValidSend3: receiver message: selector block: [:t | ^ true] arguments: {}.
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 2/13/2013 13:55'!
checkValidSend3: sender message: selector block: block arguments: arguments
	
	| returnValue argumentsWithSelf |	
		
	"Logger show: self class printString ; show: ' ' ; show: selector ; cr."
	"self logSendType: sender."
		
	(self == sender) ifTrue: [ 
		argumentsWithSelf := arguments copyWithFirst: self. 	
		^ block valueWithArguments: argumentsWithSelf .
	].
			
	"parent sends message to child"
	(self owner == sender) ifTrue: [ 
		argumentsWithSelf := arguments copyWithFirst: self. 	
		returnValue:= block valueWithArguments: argumentsWithSelf .
		^ self handleViolation: sender returnValue: returnValue. 
	].
	
	"child sends message to parent"
	(self == sender owner) ifTrue: [ 
		self handleViolation: sender arguments: arguments. 
		argumentsWithSelf := arguments copyWithFirst: self. 	
		^ block valueWithArguments: argumentsWithSelf.
	].

	"object sends message to a siblings"
	(self owner == sender owner ) ifTrue: [ 
		self handleViolation: sender arguments: arguments. 
		argumentsWithSelf := arguments copyWithFirst: self. 	
		returnValue:= block valueWithArguments: argumentsWithSelf .
		^ self handleViolation: sender returnValue: returnValue. 
	].
	
	self handleFilters: sender selector: selector.
	self handleViolation: sender arguments: arguments. 
	argumentsWithSelf := arguments copyWithFirst: self. 	
	returnValue:= block valueWithArguments: argumentsWithSelf .
	^ self handleViolation: sender returnValue: returnValue. 
	! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 6/25/2012 15:01'!
copy
	<meta>
	| copy |
	copy := super copy. 
	copy ownerNoCheck: self owner. 
	^ copy. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 2/13/2013 13:55'!
handleViolation: sender argument: argument
	
	| rp sp violationOwners tempArgument |
	
	"All objects can access objects owned by the world "
	(argument owner == WorldOwner getInstance) ifTrue: [ ^ argument ].
	"The receiver own the argument"
	(self == argument owner ) ifTrue: [ ^argument ].
	"any reference the sender has can be passed down without violation"
	(self owner == sender ) ifTrue: [ ^argument ].
	
	"Let   a//b denotes the out boudnaries between a and b.
	s=sender, r=receiver, v=return value, p=argument 
	We need to trigger boundary violations for r//p - s//p. "
	
	rp := self computePathFrom: self to: argument. "compute r//p"
	sp := self computePathFrom: sender to: argument. "compute s//p"
	violationOwners := rp removeAllIfPresent: sp.  "compute r//p - s//p"
	
	tempArgument := argument .
	violationOwners reverse do: [ :boundary |
		( boundary canCrossBoundary: tempArgument ) ifTrue: [
			boundary doCrossBoundary: tempArgument. 
		] ifFalse: [
		
			"recompute rp because removeAllIfPresent modified it"
			rp := self computePathFrom: self to: argument.
			Logger show: ( 'r//p ', rp printString ) ; cr.
			Logger show: ( 's//p ', sp printString ) ; cr. 
			Logger show: ( 'r//p - s//p ', violationOwners printString ) ; cr.
				
			Logger show: ( 'sender: ', sender printString  ); cr.
			Logger show: ( 'receiver: ', self printString) ; cr. 
			Logger show: ( 'parameter: ', argument printString  ); cr.
		
			 tempArgument := boundary doNotCrossBoundary: tempArgument sender: sender.
		]
	].
	^ tempArgument. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 2/13/2013 13:55'!
handleViolation: sender returnValue: returnValue 
	
	| sv rv violationOwners |
	
	"an object can return itself"
	(returnValue == self ) ifTrue: [ ^ returnValue ].
	(returnValue owner == WorldOwner getInstance) ifTrue: [ ^ returnValue ].
		
	"Let   a//b denotes the out boudnaries between a and b.
	s=sender, r=receiver, v=return value, p=argument 
	We need to trigger boundary violations for s//v - r//v. "
	
	sv := self computePathFrom: sender to: returnValue. "compute s//v"
	rv := self computePathFrom: self to: returnValue. "compute r//v"
	violationOwners := sv removeAllIfPresent: rv.  "compute s//v - r//v"
	
	violationOwners reverse do: [ :boundary |
		( boundary canCrossBoundary: returnValue ) ifTrue: [
			boundary doCrossBoundary: returnValue. 
		] ifFalse: [
			
			"Compute sv again because removeAllIfAbsent modified it"
			sv := self computePathFrom: sender to: returnValue.
			Logger show: ( 's//v ', sv printString ) ; cr.
			Logger show: ( 'r//v ', rv printString ) ; cr.
			Logger show: ( 's//v - r//v ', violationOwners printString ) ; cr.
			
			Logger show: ( 'sender: ', sender printString  ); cr.
			Logger show: ( 'receiver: ', self printString) ; cr. 
			Logger show: ( 'value: ', returnValue printString  ); cr.
		
			"TODO should be recursive if mutlipe non crossable barriers are crossed"
			^ boundary doNotCrossBoundary: returnValue sender: sender.
		]
	].
	^ returnValue. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 7/5/2012 15:32'!
isAccessibleFrom: aSource
	| interfaces |
	interfaces := self class allPragmas .
	self handleFilters: aSource selector: #any interfaces: interfaces. 
	
! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 2/13/2013 13:55'!
isAccessibleFromAllReferencs

	"This check is too slow in practice"
	true ifTrue: [ ^self ].
	
	self pointersTo do: [ :source | 
		( source isKindOf: OwnedObject3 ) ifTrue: [
			"Logger show: 'Check from' ; show: source class asString ; cr.  "	
			self isAccessibleFrom: source ]
	]! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 6/27/2012 17:26'!
owner
	dynamicOwner isNil ifTrue: [ dynamicOwner := WorldOwner getInstance ].
	^ dynamicOwner. ! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 2/13/2013 13:55'!
owner: newOwner
	"Logger show:  'Attempt to transfer ownership (object: ' ; show: self class printString ;
	show: ', candidate owner: ' ; show:  newOwner class printString ; show:  ')' ; cr ."
	(newOwner acceptOwnershipOf: self ) ifTrue: [
		WorldOwner resetPathCache.
		dynamicOwner := newOwner. 
		"Logger show:  'Ownership transfer succeeded' ; cr ."
		self isAccessibleFromAllReferencs.
		
	] ifFalse: [ 
		Logger show: thisContext traceString  ; cr. 
		TransferError signal
	 ].
	"TODO the method does not return itself, as this might create violations"
	 ^nil. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'pmaer 7/4/2012 15:20'!
ownerNoCheck: newOwner
	"TODO this one should ideally never be used. Momentary necessary because of instrumented / not instrumente d code"
	"setter for owner"
	WorldOwner resetPathCache.
	dynamicOwner := newOwner.! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 2/13/2013 13:55'!
thisSender
	"Logger show: 'thisSender: '; show: thisContext traceString  ; cr. "
	"TODO ugly and depends on the rewriting with synthetic closures etc"
	( thisContext sender sender sender method selector = 
		#checkValidSend3:message:block:arguments: ) ifTrue: [
			^ thisContext sender sender sender sender receiver.
		] ifFalse: [
			^ thisContext sender sender receiver.
		]
	

	! !

RBLiteralValueNode subclass: #RBAmopLiteralValueNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopLiteralValueNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:43'!
isAmopLiteralValueNode
	^true! !

!RBAmopLiteralValueNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:35'!
needsAmopRewrite
	^false! !

RBBlockNode subclass: #RBAmopBlockNode
	instanceVariableNames: 'transformContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:39'!
isAmopBlockNode
	^true! !

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 9/12/2012 17:21'!
needsAmopRewrite 
	^false! !

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 10:05'!
transformContent
	^transformContent! !

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 10:05'!
transformContent: flag 
	transformContent := flag. ! !

!RBBlockNode methodsFor: '*amop' stamp: 'ewe 9/12/2012 17:32'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) )  not . 
	! !

Error subclass: #OwnershipError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

Error subclass: #ReadOnlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-ReadOnly'!

Error subclass: #RevokedMembraneError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!RBMethodNode methodsFor: '*amop' stamp: 'ewe 6/22/2012 13:36'!
hasMetaPragma
	^ ( self pragmas collect: [ :pragma | pragma selector ] ) includes: #meta! !

!RBMethodNode methodsFor: '*amop' stamp: 'ewe 2/13/2013 10:26'!
isAmopMeta
	^ self hasMetaPragma! !

RBMessageNode subclass: #RBAmopMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopMessageNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:37'!
isAmopMessageNode
	^true! !

!RBAmopMessageNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:35'!
needsAmopRewrite
	^false! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 1/31/2013 12:34'!
isBypass
	^false. 
	"^ self selector = #ifTrue::ifFalse: or: [  self selector = #ifFalse:ifTrue: or: [ self selector = #ifTrue: or: [ self selector = #ifFalse: ]]]"! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 2/8/2013 13:15'!
mapHardcodedVmMessage

	( selector = #== ) ifTrue: [
		selector := #identityEquals: .
		^self. 
	].
	( selector = #= ) ifTrue: [
		selector := #equals: .
		^self. 
	].! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 11:46'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	"^( ({ #trap:selector:arguments: . #receiverProxy . #literalTrap: . #newTrap: . #readField: . #writeField:value: } includes: self selector) or: 
	    [ (self parent isMessage and: [ self parent selector = #newTrap: ]) or:
	    [ (self parent parent isAmopBlockNode and: [ self parent parent transformContent not ] ) ]] )  not . "
	^ (self parent isMessage and: [ self parent parent isAmopBlockNode and: [ self parent parent transformContent not ]] ) not
	! !

RBCompiler subclass: #AmopCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!AmopCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
translate: aProgramNode
AmopVisitor new visitNode: aProgramNode methodNode class: class ..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompiler3 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor3 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBLiteralArrayNode subclass: #RBAmopLiteralArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:43'!
isAmopLiteralArrayNode
	^true! !

!RBAmopLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:43'!
needsAmopRewrite
	^false! !

RBArrayNode subclass: #RBAmopArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopArrayNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:35'!
isAmopArrayNode
	^true! !

!RBAmopArrayNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:35'!
needsAmopRewrite
	^false! !

!RBArrayNode methodsFor: '*amop' stamp: 'ewe 2/13/2013 12:11'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) or: 
	[  (self parent isMessage and: [ self parent selector = #trap:selector:arguments:  ] ) ] )  not . 
	! !

!RBLiteralNode methodsFor: '*amop' stamp: 'ewe 2/13/2013 12:11'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	
	(self parent isMessage and: [ self parent receiver = self  ]) ifTrue: [ ^ true ].
	
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ]) or: 
	[(self parent isMessage and: [ self parent selector = #trap:selector:arguments:  ])])   not . 
	! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 09:37'!
isAmopArrayNode
	^false! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 9/3/2012 16:39'!
isAmopBlockNode
	^false! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 09:43'!
isAmopLiteralArrayNode
	^false! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 09:43'!
isAmopLiteralValueNode
	^false! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 09:36'!
isAmopMessageNode
	^false! !

!RBProgramNode methodsFor: '*amop' stamp: 'ewe 2/14/2013 09:36'!
isAmopVariableNode
	^false ! !

RBProgramNodeVisitor subclass: #AmopVisitor
	instanceVariableNames: 'currentClass skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 12:06'!
acceptArrayNode: anArrayNode 
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	(skip) ifTrue: [
		^super acceptArrayNode: anArrayNode 
	].

	Logger show: 'ArrayNode';cr. 
	
	(anArrayNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'.
		 
		orignalMessageNode := RBAmopMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	RBAmopArrayNode statements: anArrayNode statements .	 }.
		
		anArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	anArrayNode children do: [:each | self visitNode: each]. ! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:56'!
acceptAssignmentNode: anAssignmentNode 
	| myself  field proxyMessageNode trapMessageNode |
	
	(skip) ifTrue: [
		^super acceptAssignmentNode: anAssignmentNode 
	].
	
	Logger show: 'Assignment'; cr. 
	
	(currentClass instVarNames includes:  anAssignmentNode variable name ) ifFalse: [
		^ super acceptAssignmentNode: anAssignmentNode 	
	].
	
	"self visitNode: anAssignmentNode value."
	myself := self buildVariableNode: 'self'. 
	field := self buildAmopLiteralNode: anAssignmentNode variable name.  
		
	trapMessageNode := RBAmopMessageNode receiver:  myself
		 	selector: #writeField:value: 
			arguments: { field .  anAssignmentNode value }.
			
	anAssignmentNode replaceWith: trapMessageNode.		
	^ super visitNode: trapMessageNode.	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 10:14'!
acceptBlockNode: aBlockNode 
	| myself proxyMessageNode orignalMessageNode |

	(skip) ifTrue: [
		^super acceptBlockNode: aBlockNode 
	].

	Logger show: 'Block'; cr. 

	(aBlockNode needsAmopRewrite ) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
		
		orignalMessageNode := RBAmopMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	( RBAmopBlockNode arguments: aBlockNode 
						 arguments body: aBlockNode body ) transformContent: true }.
		
		aBlockNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 13:28'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	(skip) ifTrue: [
		^super acceptLiteralArrayNode: aRBLiteralArrayNode 
	].

	Logger show: 'LiteralArrayNode'; cr. 

	(aRBLiteralArrayNode needsAmopRewrite) ifTrue: [
		myself := self buildVariableNode: 'self'. 
				
		orignalMessageNode := RBAmopMessageNode receiver: myself
			selector: #literalTrap:
			arguments: {  	RBAmopArrayNode statements: ( OrderedCollection withAll:  
				aRBLiteralArrayNode contents  ) }.
		
		aRBLiteralArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	aRBLiteralArrayNode contents do: [:each | self visitNode: each].
	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 10:24'!
acceptLiteralNode: aLiteralNode

	(skip) ifTrue: [
		^super acceptLiteralNode: aLiteralNode
	].

	Logger show: 'LiteralNode'; cr. 
	
	(aLiteralNode needsAmopRewrite) ifTrue: [
		| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
			
		orignalMessageNode := RBAmopMessageNode receiver: myself
			selector: #literalTrap: 
			arguments: { 
				self buildAmopLiteralNode: aLiteralNode value 
			 }.
		
		aLiteralNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	]! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 10:25'!
acceptMessageNode: messageNode 

	(skip) ifTrue: [
		^super acceptMessageNode:  messageNode.
	].

	( messageNode isSuperSend ) ifTrue: [  
		^super acceptMessageNode:  messageNode.
	].

	( messageNode isBypass ) ifTrue: [  
		^super acceptMessageNode:  messageNode.
	].

	^self acceptNormalMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:30'!
acceptMethodNode: aMethod
	skip := aMethod isAmopMeta.
	aMethod addSelfReturn. 
	^ super acceptMethodNode: aMethod.
	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 13:38'!
acceptNormalMessageNode: messageNode 

	(messageNode needsAmopRewrite) ifTrue: [
		| myself block selector sender arguments proxyMessageNode orignalMessageNode |

		Logger show: 'Rewrite message (before):  '; show: messageNode selector; cr. 
		"Some messages are hardcoded in the VM, we must make sure they are intercepted as well"
		messageNode mapHardcodedVmMessage. 
		Logger show: 'Rewrite message (after):  '; show: messageNode selector; cr. 
		block := self buildSyntheticBlock: messageNode.
		arguments := RBAmopArrayNode statements: messageNode arguments. 
		selector := self buildAmopLiteralNode: messageNode selector.  
		
		orignalMessageNode := RBAmopMessageNode receiver:  messageNode receiver 
		 	selector: #trap:selector:arguments:
			arguments: { block . selector . arguments  }.
		 
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 13:52'!
acceptVariableNode: aVariableNode

	| myself  field proxyMessageNode trapMessageNode |
	
	(skip) ifTrue: [
		^super acceptVariableNode: aVariableNode
	].
	
	(aVariableNode name = 'self'  ) ifTrue: [
		myself := self buildVariableNode: 'self'. 
			
		proxyMessageNode := RBAmopMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
				
		aVariableNode replaceWith: proxyMessageNode.	
			
		"For self, we do *not* visit the replaced not, otherwise we will recurse"	
	].
		
	( aVariableNode needsAmopRewrite and: [ aVariableNode name first isUppercase ] ) ifTrue: [
		Logger show: 'Class'. 
		myself := self buildVariableNode: 'self'. 
		field := self buildAmopVariableNode: aVariableNode name. 
			
		trapMessageNode := RBAmopMessageNode receiver:  myself
		 	selector: #classTrap: 
			arguments: { field }.
			
		  aVariableNode  replaceWith: trapMessageNode.	
		^ super visitNode: trapMessageNode.	
	 ].
		
	( currentClass instVarNames includes: aVariableNode name ) ifTrue: [
		Logger show: 'Variable'.
		myself := self buildVariableNode: 'self'. 
		field := self buildAmopLiteralNode: aVariableNode name. 
				
		trapMessageNode := RBAmopMessageNode receiver:  myself
		 	selector: #readField:
			arguments: { field }.
			
		  aVariableNode  replaceWith: trapMessageNode.	
		^ super visitNode: trapMessageNode.	
	]! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:43'!
buildAmopLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBAmopLiteralValueNode literalToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:44'!
buildAmopVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBAmopVariableNode identifierToken: literal. ! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:43'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 11:51'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBAmopMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBAmopBlockNode 
			arguments: blockArguments
			body: blockBody. 
		block transformContent: false. 	
			
		^ block
		! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:44'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:30'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
visitNode: aNode class: class
	currentClass := class. 
	^self visitNode: aNode. ! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor3
	instanceVariableNames: 'skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 14:00'!
acceptArrayNode: arrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptArrayNode: arrayNode. ].
	
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 13:59'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptLiteralArrayNode: literalArrayNode. ].
	
	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/27/2012 14:47'!
acceptMessageNode: messageNode 
	| logging |
	"logging = true: self and super will be converted to  self track: [ original method ] selector: #selector"
	logging:= false.
	
	"Excluse certain methods (see acceptMethodNode)"
	skip ifTrue: [ ^super acceptMessageNode: messageNode. ].

	( logging and: [ messageNode isSelfSend or: [messageNode isSuperSend ] ] ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^self acceptSelfAndSuperMessageNode: messageNode.
	]
	ifFalse: [
		"normal case"
		^self acceptNormalMessageNode: messageNode.
	].! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 7/10/2012 17:05'!
acceptMethodNode: aMethod
	VariableNameCounter resetCounter. 
	skip := aMethod isOwernshipMeta.
	^ super acceptMethodNode: aMethod.
	! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/28/2012 09:14'!
acceptNormalMessageNode: messageNode 

	"Exclude self and super sends and few other cases"
	(messageNode isExcluded ) 
		ifTrue: [ ^super acceptMessageNode: messageNode. ].	
		
				
	(messageNode needsOwnershipRewrite) ifTrue: [
		| block selector sender arguments newMessageNode |
			
		"block := self buildVariableNode: 'self'. "
		block := self buildSyntheticBlock: messageNode .
		selector := self buildLiteralNode: messageNode selector. 
		sender := self buildVariableNode: 'self'.
		arguments := RBOwnershipArrayNode statements: messageNode arguments.
				
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend3:message:block:arguments:
			arguments: { sender. selector. block. arguments}.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 16:10'!
acceptSelfAndSuperMessageNode: messageNode 

"Send type logger, special block for this case:"
	
	"Exclude self thisSender"
	(messageNode isSelfSend and: [messageNode selector = #thisSender]) ifTrue: [
		 ^super acceptMessageNode: messageNode.
		].
	
	 ((messageNode isSelfSend or: [ messageNode isSuperSend ])  and: [messageNode needsOwnershipRewrite ])
		ifTrue: [ 
			| block selector arguments newMessageNode receiver |
			
			block:= self buildTrackBlock: messageNode .
			selector := self buildLiteralNode: messageNode selector. 
				
			newMessageNode:= RBMessageNode receiver:  (self buildVariableNode: 'self')
		 	selector: #track:selector:
			arguments: { block. selector.}.
		
			messageNode replaceWith: newMessageNode.
			
			^ super visitNode: newMessageNode.
			
			
			].
	"------------------------------------------"
	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:58'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:33'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBOwnershipBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 12:09'!
buildTrackBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiver := messageNode receiver.
		blockBodyMessageArguments:= messageNode arguments.

		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		block := RBOwnershipBlockNode
			body: blockBody. 
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:30'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:29'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

TestCase subclass: #BaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!BaseTest methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
instantiateAndSetUp: class
	^ self instantiateAndSetUp: class handlerClass: MetaProxyHandler.! !

!BaseTest methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
instantiateAndSetUp: class handlerClass: handlerClass
	| o  nilProxy classProxy proxy  |
	BaseTracingHandler reset.
	
	"set nil as starting object"
	nilProxy := ValueProxy resolve: nil. 
	MetaProxyHandler receiverProxy: nilProxy handler: nilProxy handler. 
	
	"instantiate"
	classProxy := class . "ValueProxy resolve: class ."
	o := classProxy trap: [ :cls | cls new  ] selector: #new arguments:{ } .  
	
	"proxy with desired handler "
	proxy := Proxy for: o handlerClass: handlerClass. 
	
	Logger show: '-----------------';cr.
	^ proxy! !

BaseTest subclass: #DynamicBindingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-DynamicBinding'!

!DynamicBindingTest methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 13:17'!
testSteps
	| proxy base res |
	base := DynamicBindingTester  trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	res := base  trap: [ :cls | cls testSteps   ] selector: #testSteps arguments:{ } .   
	self assert: res baseObject  == 168! !

BaseTest subclass: #OwnershipTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Ownership'!

!OwnershipTest methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:43'!
testListHead
	| proxy res |
	proxy := self instantiateAndSetUp: OwnershipTester handlerClass: OwnershipHandler.
	self should:	[ res := proxy trap: [ :o | o testListHead ] selector: #testListHead arguments: #() .. ] raise: OwnershipError  .! !

!OwnershipTest methodsFor: 'as yet unclassified' stamp: 'ewe 2/15/2013 11:59'!
testListOwner 
	| proxy res |
	proxy := self instantiateAndSetUp: OwnershipTester handlerClass: OwnershipHandler.
	 res := proxy trap: [ :o | o testListOwner ] selector: #testListOwner arguments: #() .. 
	"Minor improvement: res handler == proxy handler
	proxy can be different, but handler should be the same"
	self assert: res baseObject == proxy baseObject. ! !

BaseTest subclass: #TestBaseHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

BaseTest subclass: #TestClosureSelf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testBooleanClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doBooleanClassClosure  ] selector: #doBooleanClassClosure arguments:{ } . 
	self assert: ( res= Facade  )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testHelperClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doHelperClassClosure  ] selector: #doHelperClassClosure arguments:{ } . 
	self assert: ( res= Facade  )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testSelfClass
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doSelfClass ] selector: #doSelfClass arguments:{ } . 
	self assert: ( res   = Facade )  .! !

!TestClosureSelf methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testSelfClassClosure
	| proxy  res |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	"context doSelfClass  is rewritten as follows by amop compiler"
	res := proxy trap: [ :t1 | t1 doSelfClassClosure ] selector: #doSelfClassClosure arguments:{ } . 
	self assert: ( res = Facade  )  .! !

BaseTest subclass: #TestInstantiation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TestInstantiation methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testInitializeNil
	| o helper key  |
	o := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	self assert: (o handler isKindOf: MetaProxyHandler ).
	self assert: (o handler target isKindOf: Facade ).
	helper :=  o baseObject  instVarNamed: #helper .
	self assert: helper isNil not.  
	key := helper baseObject instVarNamed: #key. 
	self assert: ( key isKindOf: NilProxy )
	! !

BaseTest subclass: #TestMembrane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Membrane'!

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testInMembrane
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testInMembrane ] selector: #testInMembrane arguments: #() .
	self assert: ( res  baseObject = 42 )  .! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:52'!
testInMembraneIndempotence
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testInMembraneIndempotence ] selector: #testInMembraneIndempotence arguments: #() .
	res := res baseObject .
	self assert: ( res first == res second ) not .! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:54'!
testInMembraneIndempotence2
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testInMembraneIndempotence2 ] selector: #testInMembraneIndempotence2 arguments: #() .
	self assert: res baseObject! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testInRevokeMembrane 
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	
	self should: [ 
		 tester trap: [ :o | o testInRevokeMembrane ] selector: #testInRevokeMembrane arguments: #() .
	] raise: RevokedMembraneError! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testOutMembrane
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testOutMembrane ] selector: #testOutMembrane arguments: #() .
	self assert: ( res  baseObject = 42 )  .! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 17:16'!
testOutMembraneIndempotence
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	res := tester trap: [ :o | o testOutMembraneIndempotence2 ] selector: #testOutMembraneIndempotence2 arguments: #() .
	self assert: res baseObject ! !

!TestMembrane methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 14:14'!
testOutRevokeMembrane 
	| tester res |
	tester := self instantiateAndSetUp: MembraneTester .
	
	self should: [ 
		 tester trap: [ :o | o testOutRevokeMembrane ] selector: #testOutRevokeMembrane arguments: #() .
	] raise: RevokedMembraneError! !

BaseTest subclass: #TestMeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TestMeta methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:20'!
testDoerBaseOnBase
	| doer res target  |
	doer := DoerBaseImpl  trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	target := DoerTarget  trap: [ :cls | cls new  ] selector: #new arguments:{ } . 
	res := doer  trap: [ :o :o2 | o computeSumOnObject: o2 ] selector: #computeSumOnObject: arguments:{ target } .
	self assert: ( res  handler target = 84 )  .
	self should:	[ doer trap: [ :o :o2 | o invokeTrapForComputeSumOnObject: o2 ] selector: #invokeTrapForComputeSumOnObject: arguments:{ target }  ] raise: MessageNotUnderstood .! !

!TestMeta methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:32'!
testDoerBaseOnProxy
	| doer res target  |
	doer := DoerBaseImpl  trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	target := self instantiateAndSetUp: DoerTarget handlerClass: TracingHandlerSelfSend. 
	
	res := doer  trap: [ :o :o2 | o computeSumOnObject: o2 ] selector: #computeSumOnObject: arguments:{ target } .
	self assert: ( res  baseObject= 84 )  .
	self assert: BaseTracingHandler 	counter = 6. 
		
	BaseTracingHandler reset.
	self should:	[ doer trap: [ :o :o2 | o invokeTrapForComputeSumOnObject: o2 ] selector: #invokeTrapForComputeSumOnObject: arguments:{ target }  ] raise: MessageNotUnderstood .! !

!TestMeta methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:21'!
testDoerMetaOnBase
	| doer res target  |
	doer := DoerMetaImpl  trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	target := DoerTarget  trap: [ :cls | cls new  ] selector: #new arguments:{ } . 
	res := doer  trap: [ :o :o2 | o computeSumOnObject: o2 ] selector: #computeSumOnObject: arguments:{ target } .
	self assert: ( res  handler target = 84 )  .
	self should:	[ doer trap: [ :o :o2 | o invokeTrapForComputeSumOnObject: o2 ] selector: #invokeTrapForComputeSumOnObject: arguments:{ target }  ] raise: MessageNotUnderstood .! !

!TestMeta methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 14:32'!
testDoerMetaOnProxy
	| doer res target  |
	doer := DoerMetaImpl trap: [ :cls | cls new  ] selector: #new arguments:{ } .   
	target := self instantiateAndSetUp: DoerTarget handlerClass: TracingHandlerSelfSend. 
	self should: [ doer  trap: [ :o :o2 | o computeSumOnObject: o2 ] selector: #computeSumOnObject: arguments:{ target } ] raise: MessageNotUnderstood .
	
	BaseTracingHandler reset.
	res := doer trap: [ :o :o2 | o invokeTrapForComputeSumOnObject: o2 ] selector: #invokeTrapForComputeSumOnObject: arguments:{ target }  .
	self assert: ( res  baseObject  = 84 )  .
	self assert: BaseTracingHandler 	counter = 6. 
	! !

BaseTest subclass: #TestReadOnly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-ReadOnly'!

!TestReadOnly methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:09'!
testClassMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: ReadOnlyChainingHandler.
	self should:	[ res := proxy trap: [ :o | o classMemoizeSum ] selector: #classMemoizeSum arguments: #() . ] raise: ReadOnlyError .! !

!TestReadOnly methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:09'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: ReadOnlyChainingHandler.
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

!TestReadOnly methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:09'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: ReadOnlyChainingHandler.
	self should:	[ res := proxy trap: [ :o | o memoizeSum ] selector: #memoizeSum arguments: #() . ] raise: ReadOnlyError .! !

!TestReadOnly methodsFor: 'as yet unclassified' stamp: 'ewe 2/12/2013 16:09'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: ReadOnlyChainingHandler.
	res := proxy trap: [ :o | o mockSum ] selector: #mockSum arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

BaseTest subclass: #TestTracing
	uses: TNoopTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

TestTracing class
	uses: TNoopTrap classTrait
	instanceVariableNames: ''!

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testClosure
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy :=  Facade basicNew. 
	MetaProxyHandler receiverProxy:  proxy handler: #NoHandler.. 
	proxy initialize. 
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	"closures are literal that must be wrapped"
	block  := ClosureProxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	"context do: block with: proxy is rewritten as follows by amop compiler"
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res  baseObject   = 84 )  .
	self assert: ( BaseTracingHandler counter = 10 )  . ! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testClosure2
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	block  := ClosureProxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	"context do: block with: proxy is rewritten as follows by amop compiler"
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res  baseObject   = 84 )  .
	self assert: ( BaseTracingHandler counter = 10 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 17:30'!
testNoSelfSendAndNoSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerNoSelfSend .
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res baseObject  = 42 )  .
	self assert: ( BaseTracingHandler counter = 3 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 17:30'!
testNoSelfSendAndSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerSelfSend .
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res baseObject = 42 )  .
	self assert: ( BaseTracingHandler counter = 3 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 17:30'!
testSelfSendAndNoSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerNoSelfSend .
	res := proxy trap: [ :o | o twiceComputeSum ] selector: #twiceComputeSum arguments: #() .
	self assert: ( res baseObject  = 84 )  .
	self assert: ( BaseTracingHandler counter = 6 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 17:31'!
testSelfSendAndSelfTracing 
	| proxy res |
	proxy := self instantiateAndSetUp: Facade handlerClass: TracingHandlerSelfSend .
	res := proxy trap: [ :o | o twiceComputeSum ] selector: #twiceComputeSum arguments: #() .
	self assert: ( res baseObject = 84 )  .
	self assert: ( BaseTracingHandler counter = 8 )  .! !

!TestTracing methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testTracingReadonly
	| proxy context res block |
	"TODO can closure flow across base and meta level?"
	proxy := self instantiateAndSetUp: Facade handlerClass: MetaProxyHandler .
	context := self instantiateAndSetUp: Scope handlerClass: TracingHandlerSelfSend .
	context := Proxy for: context handlerClass: ReadOnlyChainingHandler.
	" [ :o |  o twiceComputeSum ] is rewritten as follows by amop compiler "
	block  := Proxy for:  [ :o | o  trap: [ :t1 | t1 twiceComputeSum ] selector: #twiceComputeSum arguments: #() . ].
	res := context trap: [ :t1 :t2 :t3 | t1 do: t2 with: t3 ] selector: #do:with: arguments:{ block. proxy } . 
	self assert: ( res baseObject   = 84 )  .
	self assert: ( BaseTracingHandler counter = 10 )  .! !

BaseTest subclass: #TestTransparency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Test-Core'!

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 1/30/2013 14:59'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o computeSum ] selector: #computeSum arguments: #() .
	self assert: ( res handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testIdentity
	| o proxy1 proxy2  res nilProxy  |
	
	"set nil as starting object"
	nilProxy := ValueProxy resolve: nil. 
	MetaProxyHandler receiverProxy: nilProxy handler: nilProxy handler. 
	o := Facade trap: [ :cls | cls new  ] selector: #new arguments:{ } .  
	proxy1 := Proxy for: o. 
	proxy2 := Proxy for: o. 
	
	Logger show: '-----------------';cr.
	res := proxy1 trap: [ :o1 :o2 | o1 isEqualTo:  o2 ] selector: #isEqualTo: arguments: { proxy2 } .
	self assert: ( res baseObject = true  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/21/2013 14:15'!
testIdentity2
	| o proxy1 proxy2 proxyAndHandler res nilProxy  |
	"set nil as starting object"
	nilProxy := ValueProxy resolve: nil. 
	MetaProxyHandler receiverProxy: nilProxy handler: nilProxy handler. 
	o := Facade trap: [ :cls | cls new  ] selector: #new arguments:{ } .  
	proxy1 := Proxy for: o. 
	proxy2 := Proxy for: o. 
	Logger show: '-----------------';cr.
	res := proxy1 trap: [ :o1 :o2 | o1 isEqualTo2:  o2 ] selector: #isEqualTo2: arguments: { proxy2 } .
	self assert: ( res baseObject = true  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/13/2013 13:55'!
testIdentity3
	| o proxy1 proxy2 proxyAndHandler res |
	proxy1 := ValueProxy resolve: 42. 
	proxy2 := ValueProxy resolve: 42. 
	Logger show: '-----------------';cr.
	res := proxy1 trap: [ :o1 :o2 | o1 identityEquals:  o2 ] selector: #identityEquals: arguments: { proxy2 } .
	self assert: ( res baseObject = true  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o memoizeSum ] selector: #memoizeSum arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: Facade..
	res := proxy trap: [ :o | o mockSum ] selector: #mockSum arguments: #() .
	self assert: ( res  handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2012 11:33'!
testReturn42
 	| proxy res  |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o return42 ] selector: #return42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] selector: #selfReturn42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o return42 ] selector: #return42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] selector: #selfReturn42 arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 16:45'!
testReturnClass42
 	| proxy res  |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o classCompute42 ] selector: #classCompute42 arguments: #() .
	self assert: ( res  == 42  )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 1/28/2013 11:53'!
testReturnObject
	| proxy res |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o returnObject ] selector: #returnObject arguments: #() .
	self assert: ( res  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] selector: #selfReturnObject arguments: #() .
	self assert: ( res   = nil ) not  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o returnObject ] selector: #returnObject  arguments: #() .
	self assert: ( res  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] selector: #selfReturnObject arguments: #() .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 2/8/2013 14:11'!
testReturnSelf
 	| proxy res  |
	proxy := self instantiateAndSetUp: Facade.
	res := proxy trap: [ :o | o returnSelf ] selector: #returnSelf arguments: #() .
	self assert: ( res  == proxy  )  .
	res := proxy trap: [ :o | o selfReturnSelf ] selector: #selfReturnSelf arguments: #() .
	self assert: (  res  == proxy )  .
	proxy := self instantiateAndSetUp: SubFacade.
	res := proxy trap: [ :o | o returnSelf ] selector: #returnSelf arguments: #() .
	self assert: ( res  == proxy )  .
	res := proxy trap: [ :o | o selfReturnSelf ] selector: #selfReturnSelf arguments: #() .
	self assert: (  res  == proxy )  .! !

RBVariableNode subclass: #RBAmopVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Compiler'!

!RBAmopVariableNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:37'!
isAmopVariableNode
	^true ! !

!RBAmopVariableNode methodsFor: 'as yet unclassified' stamp: 'ewe 2/14/2013 09:35'!
needsAmopRewrite
	^false! !

!RBVariableNode methodsFor: '*amop' stamp: 'ewe 2/8/2013 16:21'!
needsAmopRewrite
	
	^ (self parent isMessage and: [ self parent selector = #classTrap:  ])   not . 
	! !
